#!./aprlwish
#
# test.tcl
# 
# whatever to test aprl

set tcl_interactive 1
wm minsize . 1 1

set timestep   0.2
set asbtime    [expr "2*$timestep"]
set srate      44100
set blen       400
set slorate    50.0
set dur        [expr "$blen/$slorate"]

scheduler  s    -time $timestep

audiosrc  as    -buffer $asbtime -sampleRate $srate
#soundfsrc as    -buffer $asbtime -filename "tmp.aif"

bpfilter  .     -centerFreq 5000      -Qfactor 4

delay     d1    -input as -delayTime 0.1
adder     a1    -in2 as
audiosink ak

set len 100
set lstart 50
set size 1

proc scrollbarCommand {base} {
    global len size
    set dly [expr "0.01*$base"]
#    puts $dly
    d1 config -delayTime $dly
    .sb set $len $size $base $base
}

scrollbar .sb     -orient horiz -relief flat -command "scrollbarCommand"
pack .sb -expand y -fill x

.sb set $len $size $lstart $lstart

proc configval {widget param} {
    # it's tiresome and clumsy to extract the current value from the 
    # standard 'config' response - so do it with this function instead
    return [lindex [$widget config $param] 4]
}

proc cont {} {
   global flag dur
   s step
#   .ws0 push [as filled]
#   set now [configval s -now]
#   set thn [expr "$now - $dur"]
#   .tl config -maxVal $now -minVal $thn
   set flag [as more]
   if { $flag } { after 10 cont } else { set flag 1 }   
}

proc run { }  {
   global flag
   set flag 1
   cont
}

proc stop { } {
    global flag
    set flag 0
}

run

  
